package org.openxma.dsl.platform.dao.impl;

import org.openxma.dsl.platform.dao.FilterExpression;
import org.openxma.dsl.platform.dao.Filterable;

/**
 * A specification which defines an operation with one value.
 */
public abstract class UnaryExpression implements FilterExpression {

	private FilterExpression filterSpecification;

	public UnaryExpression(FilterExpression filterSpecification) {
		super();
		this.filterSpecification = filterSpecification;
	}
	
	public FilterExpression getFilterExpression() {
		return filterSpecification;
	}

	public static class NotExpression extends UnaryExpression {

		public NotExpression(FilterExpression filterSpecification) {
			super(filterSpecification);
		}

		public Object applyTo(Filterable filterable) {
			return filterable.append(this);
		}
	}
	
}
