/*******************************************************************************
 * Copyright (c) 2010 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/
package org.openxma.dsl.platform.query;

import org.openxma.dsl.platform.query.impl.ConstantExpression;
import org.openxma.dsl.platform.query.impl.LogicalExpression;
import org.openxma.dsl.platform.query.impl.ParameterExpression;
import org.openxma.dsl.platform.query.impl.RelationalExpression;
import org.openxma.dsl.platform.query.impl.SortOrderExpression;

/**
 * Visitor strategy for <code>QueryObject</code>
 * 
 * @see QueryObject
 */
public interface QueryContext {

    Object accept(QueryObject queryObject);

    Object accept(RelationalExpression relationalExpression);

    Object accept(LogicalExpression logicalExpression);

    Object accept(ParameterExpression namedParameterExpression);

    Object accept(ConstantExpression constantExpression);

    Object accept(SortOrderExpression sortOrderExpression);

}
