package org.openxma.dsl.platform.valueobject;

import java.util.Arrays;

public class ValueObjectByteArray extends ValueObject<byte[]> {

    private static final long serialVersionUID = 1L;

    public ValueObjectByteArray(byte[] value) {
        super(value.clone());
    }

    @Override
    public byte[] getValue() {
        return super.getValue().clone();
    }

    @SuppressWarnings("unchecked")
    @Override
    public boolean equals(Object pObj) {
        if (pObj == null) {
            return false;
        }
        if (getClass() != pObj.getClass()) {
            return false;
        }
        return Arrays.equals(super.getValue(), ((ValueObject<byte[]>) pObj).getValue());
    }

    @Override
    public int hashCode() {
        return Arrays.hashCode(super.getValue());
    }

    @Override
    public String toString() {
        return Arrays.toString(super.getValue());
    }

    public static ValueObjectByteArray newOrNull(byte[] value) {
        if (value != null) {
            return new ValueObjectByteArray(value);
        }
        return null;
    }

}
