package org.openxma.dsl.platform.valueobject;

import java.util.Date;

public class ValueObjectDate extends ValueObjectComparable<Date> {

    private static final long serialVersionUID = 1L;

    public ValueObjectDate(Date date) {
        super((Date) date.clone()); // Date is mutable
    }

    @Override
    public Date getValue() {
        return (Date) super.getValue().clone(); // Date is mutable
    }

    public static ValueObjectDate newOrNull(Date value) {
        if (value != null) {
            return new ValueObjectDate(value);
        }
        return null;
    }

}
