package org.openxma.dsl.platform.valueobject;

public class ValueObjectInteger extends ValueObjectComparable<Integer> {

    private static final long serialVersionUID = 1L;

    public ValueObjectInteger(Integer value) {
        super(value);
    }

    public static ValueObjectInteger newOrNull(Integer value) {
        if (value != null) {
            return new ValueObjectInteger(value);
        }
        return null;
    }

    public static ValueObjectInteger newOrNull(String value) {
        if (value != null && value.length() > 0) {
            return new ValueObjectInteger(Integer.valueOf(value));
        }
        return null;
    }

}
