package org.openxma.dsl.platform.valueobject;

import java.sql.Timestamp;
import java.util.Date;

public class ValueObjectTimestamp extends ValueObjectComparable<Date> {

    private static final long serialVersionUID = 1L;

    public ValueObjectTimestamp(Timestamp value) {
        super((Timestamp) value.clone()); // Timestamp is mutable
    }

    @Override
    public Timestamp getValue() {
        return (Timestamp) super.getValue().clone(); // Timestamp is mutable
    }

    public static ValueObjectTimestamp newOrNull(Timestamp value) {
        if (value != null) {
            return new ValueObjectTimestamp(value);
        }
        return null;
    }

}
