package org.openxma.dsl.platform.xma.client;

import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Widget;
import org.openxma.dsl.platform.xma.client.browse.BrowseMode;
import org.openxma.dsl.platform.xma.client.effects.Effect;
import org.openxma.dsl.platform.xma.client.effects.MouseEffect;

import at.spardat.xma.component.ComponentClient;
import at.spardat.xma.mdl.AttachmentExceptionClient;
import at.spardat.xma.mdl.IWModelClient;
import at.spardat.xma.page.PageClient;

public abstract class DslPageClient extends PageClient {

    public DslPageClient(ComponentClient component, boolean stateless) {
        super(component, stateless);
    }

    public DslPageClient(PageClient parent, boolean stateless) {
        super(parent, stateless);
    }

    protected Control createBrowseWidget(Control editControl, int style) {
        return BrowseMode.getInstance().createBrowseWidget(editControl, style);
    }

    protected void attachBrowseWidget(IWModelClient wModel, Control browseControl) {
        BrowseMode.getInstance().attachBrowseWidget(wModel, browseControl);
    }

    public void attachBrowseWidgets() {
    }

    public void attachUI () throws AttachmentExceptionClient {
        super.attachUI();
        attachBrowseWidgets();
    }

    public void detachUI() {
        super.detachUI();
        BrowseMode.getInstance().detachBrowseControls(getWModels());
    }

    protected String getAppCode() {
        return "UNDEFINED";
    }
    
    protected void setEffect(final Widget widget, final Effect effect) {
        if (widget instanceof Control && effect instanceof MouseEffect) {           
            Control control = (Control)widget;
            control.addMouseTrackListener((MouseEffect)effect);
        }
    }
    
    protected void removeEffect(final Widget widget, final Effect effect) {
        if (widget instanceof Control && effect instanceof MouseEffect) {           
            Control control = (Control)widget;
            control.removeMouseTrackListener((MouseEffect)effect);
        }
    }    
}
